//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
#include "camera1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

AnsiString FNAME;

unsigned char dat[15000];
unsigned char dat1[256];
int SAdr;

struct
{
 AnsiString tag;
 AnsiString type;
 AnsiString dat1;
 AnsiString dat2;
} Field[50],Field1[50],Field2[50];
int Dat_Total,FieldPos,IFD_NUM,SubIFD_NUM;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
AnsiString strhex(AnsiString s)
{
  int i,len;
  AnsiString w;

  w="0x";
  len=s.Length()-1;
  for(i=len;i>0;i=i-2)
   {
    w=w+s.SubString(i,2);
   }
 return w;
}

AnsiString dat_anlz(AnsiString s,int flg=0,int adr=0)
{
 AnsiString tmp,wk;

 wk=s.SubString(1,4); //Tag

 wk=strhex(wk);

 switch(flg)
  {
   case 0:     //IFD0
    Field[FieldPos].tag=wk;
    if(wk=="0x8769")        //SubIFD
     {
      SAdr=adr;
     }

    break;
   case 1:
    Field1[FieldPos].tag=wk;
    break;
   case 2:   //
    Field2[FieldPos].tag=wk;
    break;
  }

 tmp=wk+" ";

 wk=s.SubString(5,4);
 wk=strhex(wk);
 switch(flg)
  {
   case 0:
    Field[FieldPos].type=wk;
    break;
   case 1:
    Field1[FieldPos].type=wk;
    break;
   case 2:
    Field2[FieldPos].type=wk;
    break;
  }

 tmp=tmp+wk+" ";
 wk=s.SubString(9,8);

 wk=strhex(wk);
 switch(flg)
  {
   case 0:
    Field[FieldPos].dat1=wk;
    break;
   case 1:
    Field1[FieldPos].dat1=wk;
    break;
   case 2:
    Field2[FieldPos].dat1=wk;
    break;
  }

 tmp=tmp+wk+" ";
 wk=s.SubString(17,8);

 wk=strhex(wk);
 switch(flg)
  {
   case 0:
    Field[FieldPos].dat2=wk;
    break;
   case 1:
    Field1[FieldPos].dat2=wk;
    break;
   case 2:
    Field2[FieldPos].dat2=wk;
    break;
  }

 tmp=tmp+wk+" ";

 FieldPos++;

 return tmp;
}

AnsiString adrhex(int adr,AnsiString w1)
{
  AnsiString w;

  adr=adr/2;
  w=IntToHex(adr,5);
  w=w+"H  : ";
  w=w+w1;

  return w;
}
AnsiString Field_Dat(AnsiString w,int i)
{
  AnsiString tmp,w1;
  int p,num;

      p=StrToInt(Field[i].dat2)+0xc;
      num=StrToInt(Field[i].dat1);

      strncpy(dat1,&dat[p],num);
      tmp=AnsiString::StringOfChar(' ',100);
      //strcpy̑OɂɂPOOmۂĂ
      strcpy(tmp.c_str(),dat1);
      num=num*2;
      p=p*2+1;

      w1=tmp.SubString(p,num);
      w1=Field[i].tag+"   ";
      w1=w1+w.SubString(p,num);
      w1=w1+"   "+tmp;

  return w1;
}

void analize(AnsiString w)
{
 AnsiString n,w1,w2,adr,tmp;
 int i,cnt,p,num,pos,off,n0,n1;

 Form1->Memo1->Clear();

 w1=w.SubString(1,4);
 w1=adrhex(0,w1);
 if(w1.Pos("FFD8"))
  { w2=w1+"        SOI";  }
 Form1->Memo1->Lines->Add(w2);
 off=(w.Pos("49492A")-1)/2;
 i=off;

 w1=w.SubString(5,4);
 w1=adrhex(4,w1);
 if(w1.Pos("FFE1"))    // Exif
  { w2=w1+"        APP1";
    Form1->Memo1->Lines->Add(w2);

    w1=w.SubString(9,4);
    w1=adrhex(9,w1);
    w2=w1+"        Size";
    Form1->Memo1->Lines->Add(w2);

    w1=w.SubString(13,8);
    w1=adrhex(13,w1);
    w2=w1+"    Exif";
    Form1->Memo1->Lines->Add(w2);

    w1=w.SubString(25,8);
    w1=adrhex(25,w1);
    w2=w1+"    II*";
    Form1->Memo1->Lines->Add(w2);
  }
 else
  if(w1.Pos("FFE0"))    //JFIF
   { w2=w1+"        APP0";
     Form1->Memo1->Lines->Add(w2);
   }


 Form1->Memo1->Lines->Add("");


 pos=i+1+off+8;


 w1=w.SubString(pos,8);
 w1=adrhex(pos,w1);
 Form1->Memo1->Lines->Add(w1);
 Form1->Memo1->Lines->Add("");
 Form1->Memo1->Lines->Add("IFD0");

 pos=pos+8;
 w1=w.SubString(pos,2);
 adr=adrhex(pos,w1);
 Form1->Memo1->Lines->Add(adr);

 n="0X"+w1;
 num=StrToInt(n);
 pos=pos+4;
 IFD_NUM=num;

 FieldPos=0;

 i=pos;
 for(cnt=0;cnt<num;cnt++) //IFD0
  {

   w1=w.SubString(i,24);
   w1=dat_anlz(w1,0,i);
   w1=adrhex(i,w1);

   Form1->Memo1->Lines->Add(w1);
   i=i+24;
  }
 pos=pos+(num)*24;  //IFD Offset
 w1=w.SubString(pos,8);
 w1=strhex(w1);
 adr=adrhex(pos,w1);
 Form1->Memo1->Lines->Add(adr);
 pos=StrToInt(w1);
 pos=(pos+off)*2+1;

 w1=w.SubString(pos,4); //dir num
 w1=strhex(w1);
 adr=adrhex(pos,w1);

 Form1->Memo1->Lines->Add("");
 Form1->Memo1->Lines->Add("IFD1");

 Form1->Memo1->Lines->Add(adr);

 pos=pos+4;
 num=StrToInt(w1);
 FieldPos=0;

 i=pos;
 for(cnt=0;i<num;cnt++) //IFD1
  {
   w1=w.SubString(i,24);
   w1=dat_anlz(w1,1);
   w1=adrhex(i,w1);

   Form1->Memo1->Lines->Add(w1);
   i=i+24;
  }
 pos=i; //IFD Offset
 w1=w.SubString(pos,8);
 w1=strhex(w1);
 w1=adrhex(pos,w1);
 Form1->Memo1->Lines->Add(w1);

 //subIFD
 Form1->Memo1->Lines->Add("");
 Form1->Memo1->Lines->Add("SubIFD");

 FieldPos=0;
 if(SAdr >0) //SubIFD
  {
    w1=w.SubString(SAdr+16,8);
    w1=strhex(w1);
    pos=StrToInt(w1)+off;
    pos=pos*2+1;

    w1=w.SubString(pos,2); //SubIFĎ

    adr=strhex(w1);
    SubIFD_NUM=StrToInt(adr);

    adr=adrhex(pos,adr);
    Form1->Memo1->Lines->Add(adr);

    w1=strhex(w1);
    n=StrToInt(w1);

    pos=pos+4;
    i=pos;
    for(cnt=0;cnt<n;cnt++)
     {
       w1=w.SubString(i,24);
       w1=dat_anlz(w1,2);
       w1=adrhex(i,w1);

       Form1->Memo1->Lines->Add(w1);
       i=i+24;
     }
  }

/*
struct
{
 AnsiString tag;
 AnsiString type;
 AnsiString dat1;
 AnsiString dat2;
} Field[50],Field1[50],Field2[50];
*/
 Form1->Memo1->Lines->Add("");
 Form1->Memo1->Lines->Add("IFD0̈ꕔf|^̉́i^ÕItZbg+0bg̃f|^j");
 Form1->Memo1->Lines->Add("");

 int ii,len;

 for(i=0;i<IFD_NUM;i++)
  {
   w1=Field[i].tag;
   switch(StrToInt(w1))
    {
     case 0x10f: //Ж
      w1=Field_Dat(w,i);
      Form1->Memo1->Lines->Add(w1);
      break;
     case 0x110: //@
      w1=Field_Dat(w,i);
      Form1->Memo1->Lines->Add(w1);
      break;
     default:
      break;
    }

  }
      Form1->Memo1->Lines->Add(" ");

 Form1->Memo1->Lines->Add("");
 Form1->Memo1->Lines->Add("SubIFD̈ꕔf|^̉́i^ÕItZbg+0bg̃f|^j");
 Form1->Memo1->Lines->Add("");
 for(i=0;i<SubIFD_NUM;i++)
  {
   w1=Field2[i].tag;
   switch(StrToInt(w1))
    {
     case 0x829a: //Vb^|x
      pos=(StrToInt(Field2[i].dat2)+12)*2+1;
      adr=w.SubString(pos,8);
      adr=strhex(adr);
      w1=w1+"  "+adr;

      n=w.SubString(pos+8,8);
      n=strhex(n);
      w1=w1+"  "+n+"   V^|@";
      n1=StrToInt(n);
      n0=StrToInt(adr);
      w1=w1+n0+"/";
      w1=w1+n1;
      Form1->Memo1->Lines->Add(w1);
      break;
     case 0x829D: //i
      pos=(StrToInt(Field2[i].dat2)+12)*2+1;
      adr=w.SubString(pos,8);
      adr=strhex(adr);
      w1=w1+"  "+adr;

      n=w.SubString(pos+8,8);
      n=strhex(n);
      w1=w1+"  "+n+"   i@@@";
      n1=StrToInt(n);
      n0=StrToInt(adr);
      w1=w1+n0+"/";
      w1=w1+n1;
      Form1->Memo1->Lines->Add(w1);
      break;
     case 0x8827:  //ISO
      n=Field2[i].dat2;
      len=n.Length();
      n="0x"+n.SubString(len-3,4);
      tmp=StrToInt(n);

      w1=w1+"@@@@@@               ISO "+tmp;
      Form1->Memo1->Lines->Add(w1);
      break;

     case 0x9003: //Be
      pos=StrToInt(Field2[i].dat2)+12;
      num=StrToInt(Field2[i].dat1);

      strncpy(dat1,&dat[pos],num);
      tmp=AnsiString::StringOfChar(' ',100);
      //strcpy̑OɂɂPOOmۂĂ
      strcpy(tmp.c_str(),dat1);
      w1=w1+"@@@@   @@@@@@@@Be@"+tmp;
      Form1->Memo1->Lines->Add(w1);
      break;
     case 0x9207:
      n=Field2[i].dat2;
      len=n.Length();
      n="0x"+n.SubString(len-3,4);
      num=StrToInt(n);

      switch(num)
       {
        case 0:
         w1=w1+"@@@@   @@@@@@@@|h@s";
         break;
        case 1:
         w1=w1+"@@@@   @@@@@@@@|h@ρid_ϑj";
         break;
         case 2:
         w1=w1+"@@@@   @@@@@@@@|h@";
         break;
        case 3:
         w1=w1+"@@@@   @@@@@@@@|h@X|bg";
         break;
        case 4:
         w1=w1+"@@@@   @@@@@@@@|h@_";
         break;
        case 5:
         w1=w1+"@@@@   @@@@@@@@|h@}`ZOgi]j";
         break;
        case 6:
         w1=w1+"@@@@   @@@@@@@@|h@";
         break;
        case 255:
         w1=w1+"@@@@   @@@@@@@@|h@̑";
         break;
       }

      Form1->Memo1->Lines->Add(w1);
      break;
     default:
      break;
    }
  }

}
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  AnsiString w;
  int handle,i,pos;

  Form2->ShowModal();
  if(FNAME=="") return;

  w=ExtractFileExt(FNAME);
  if(w.UpperCase() !=".JPG")
   {
     Application->MessageBox("iof@t@Cł͂Ȃ悤ł","x",0);
     return;
   }
  handle=FileOpen(FNAME,0);
  FileRead(handle,dat,10000);
  FileClose(handle);
  w="";
  for(i=0;i<20000;i++)
   {
    w=w+IntToHex(dat[i],2);
   }
  pos=w.Pos("45786966");  // Exif



  if(pos == 0)
    { Application->MessageBox("Exifł͂Ȃ悤ł","x",0);
      return;
    }

  pos=w.Pos("49492A00");  // II*0
  if(pos==0)
    { Application->MessageBox("Ce`ł͂Ȃ悤ł","x",0);
      return;
    }

  analize(w);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
  int i,j,h,max;
  unsigned int p,d;
  AnsiString w,w1,sp;

  sp="                                                  ";
  if ( PrintDialog1->Execute() )
    {
      i=0;
      j=0;

      Printer()->BeginDoc();
      Printer()->Canvas->Font->Name="lr";
      Printer()->Canvas->Font->Size=12;

      w="a";

      d=(Printer()->PageWidth-150)/Printer()->Canvas->TextWidth(w);
      if((unsigned) int(d/2)*2<d)
       {
        d=d-1;
       }
      h=Printer()->Canvas->Font->Height*-1;
      max=Printer()->PageHeight/h;

      while(Memo1->Lines->Count>=i)
       {
         if(j>=max)
          {
           j=0;
           Printer()->NewPage();
          }

         w=Memo1->Lines->Strings[i];  //@

         for(p=1;p<strlen(w.c_str());p++)
          {
            if(w.SubString(p,1)=="\t")
             {
               w.Delete(p,1);
               w.Insert("        ",p);
             }
          }

         //sɓ؂Ȃ̏
rest:
         if(strlen(w.c_str())>d)
          {
           w1=w.SubString(1,d);
           Printer()->Canvas->TextOut(100,j*h,w1);
           w=w.SubString(d+1,strlen(w.c_str())-d);
           j++;
           if(j>=max)
            {
             j=0;
             Printer()->NewPage();
            }
           goto rest;

          }
         else
          {
           Printer()->Canvas->TextOut(100,j*h,w);
          }
         i++;
         j++;
       }

      Printer()->EndDoc();
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
 AnsiString txt,FileName;
  int len;
  HFILE hfil;
 if(Memo1->Text.Length()<1)
   {
       Application->MessageBox("f|^悤ł","x",0);
       return;
   }

  if(SaveDialog1->Execute()==true)
    {
     txt=Memo1->Text;
     len=txt.Length();
     hfil=_lcreat(SaveDialog1->FileName.c_str(),0);
     _lwrite(hfil,txt.c_str(),len);
     _lclose(hfil);
    } 
}
//---------------------------------------------------------------------------

